%% INITIALISATION

clear all ;
close all ;

tic % dbut temps de calcul

warning('off','MATLAB:singularMatrix') ; % dsactivation du message d'erreur rcurrent

% DIMENSIONS 2D DE LA BUILDING BOX

h = 200 ; % hauteur pice  fabriquer (mm)
l = 250+2*19 ; % largeur building box(mm)

% EPAISSEUR DE COUCHE DE PRODUCTION

layer = 1 ; % taille lement carr (mm)

% DISCRETISATION DU DOMAINE 2D

nelx = h / layer ; % nombre d'lments suivant X (hauteur)
nely = l / layer ; % nombre d'lments suivant Y (largeur)

% TEMPERATURE DE PLAQUE (POUR CONDITIONS LIMITES EN TEMPERATURE)

T_plaque = 95 ; %C

%% CHOIX INITIAUX DE BASE PAR L'UTILISATEUR

% CHOIX DE LA PIECE A SIMULER

prompt = 'RECTANGLE (1) - PYRAMIDE (2) - Y (3)   ' ;
FORME = input(prompt) ;

% CHOIX DU RATIO DE PRODUCTION DE LA PIECE

prompt = 'PIECE PRODUITE A COMBIEN DE % ?   ' ;
RATIO_PIECE = input(prompt) ;

% CHOIX CONDUCTION

prompt = 'LASER ? (1) OUI    (0) NON    ' ;
LASER = input(prompt) ;

% CHOIX CONVECTION FORCEE

prompt = 'CONVECTION FORCEE ? (1) OUI    (0) NON    ' ;
CONV_FORCEE = input(prompt) ;

% CHOIX CONVECTION NATURELLE

prompt = 'CONVECTION NATURELLE ? (1) OUI    (0) NON    ' ;
CONV_NAT = input(prompt) ;

%% EPAISSEUR DES PIECES MODELES

t_ref = 10 ; % (mm)

t(1:nely,1:nelx) = 0 ; % initialisation de la matrice des paisseurs

  if FORME == 1 % RECTANGLE
  
    t(1:nely,1:nelx) = t_ref ; % matrice des paisseurs de pice (RECTANGLE)
    t(1,1) = t_ref - 0.0000000001 ; % point modifi pour des raisons d'affichage
  
  end
  
  if FORME == 3 % Y
  
    t(1:nely,1:nelx) = t_ref ; % matrice des paisseurs de pice (Y)
    t(1,1) = t_ref - 0.0000000001 ; % point modifi pour des raisons d'affichage
  
  end 

  if FORME == 2 % PYRAMIDE
  
      for i = 1:1:nelx
        
      t(1:nely,i) = tand(3)*(nelx-i)*2*layer + t_ref ; % remplissage matrice des paisseurs de pice (PYRAMIDE)
      
      end
      
  end
  
% REPRESENTATION GRAPHIQUE DE LA REPARTITION DES "EPAISSEURS"

fig = figure('Name','Mapping paisseurs','NumberTitle','on')
hold on
colormap(jet);
contourf(t);
colorbar ;
view (-90,90) ; % inversion des axes
set(gca,'YDir','reverse') ; % retournement de l'axe Y
saveas(fig,'paisseurs');

%% CARACTERISTIQUES THERMIQUES DES MATERIAUX

% lambdas (conduction)

lambda_titane = 6.95757+0.00224*T_plaque+(1.69E-5)*T_plaque^2-(7.58E-9)*T_plaque^3 ; % (W/m.C)
lambda_poudre = 0.9315-0.00339*T_plaque+(6.55E-6)*T_plaque^2-(1.41E-9)*T_plaque^3 ; % (W/m.C)
lambda_parois = 15 ; % (W/m.C)

% REPRESENTATION DES LAMBDAS EN FONCTION DE LA TEMPERATURE

% fig = figure('Name','Lambda titane en fct de la T','NumberTitle','on')
% hold on
% x1 = linspace(1,1000,1000);
% p = [-7.58E-9 1.69E-5 0.00224 6.95757];
% v = polyval(p,x1);
% plot(x1,v),title('Lambda titane en fct de la T'),grid
% saveas(fig,'lambda_titane');
% 
% fig = figure('Name','Lambda poudre en fct de la T','NumberTitle','on')
% hold on
% x2 = linspace(1,1000,1000);
% p = [-1.41E-9 6.55E-6 -0.00339 0.9315];
% v = polyval(p,x2);
% plot(x2,v),title('Lambda poudre en fct de la T'),grid
% saveas(fig,'lambda_poudre');

% coefficients d'change par convection

 % convection forcee (argon)
 
   h_argon_force = 25 ; % coeff change par convection force (W/(m2.K))
   T_argon = 40 ; % temperature argon (C)
 
 % convection naturelle (air ambiant)

   h_air_naturel = 5 ; % coeff change par convection naturelle (W/(m2.K))
   T_air = 25 ; % temperature air ambiant (C)

%% MATRICES DES COEFFICIENTS DE CONDUCTIVITE THERMIQUE (LAMBDAS) DANS LE DOMAINE DISCRETISE

lambda(1:nely,1:nelx) = lambda_titane ; % initialisation du domaine : tout le domaine est en titane

  if FORME == 1 % RECTANGLE

    largeur_piece = 20 ; % largeur pice (rectangulaire)  fabriquer (mm)

    nb_elm_titane = largeur_piece / layer ; % nombre d'lments de la pice (rectangulaire) en titane
    nb_elm_poudre = (nely - nb_elm_titane) / 2 ; % nombre d'lments de poudre de part et d'autre de la pice

    lambda(1:nb_elm_poudre,1:nelx) = lambda_poudre ; % partie droite du domaine avec de la poudre
    lambda(nely-nb_elm_poudre+1:nely,1:nelx) = lambda_poudre ; % partie gauche du domaine avec de la poudre

  end
  
  if FORME == 3 % Y

     % partie basse Y

     largeur_bas_piece = 20 ; % largeur bas de la pice (Y)  fabriquer (mm)
     hauteur_bas_piece = 50 ; % hauteur bas de la pice (Y)  fabriquer (mm)

     nb_elm_titane_bas_piece = largeur_bas_piece / layer ; % nombre d'lments bas de la pice (Y)  fabriquer (mm)
     nb_elm_poudre_bas_piece = (nely - nb_elm_titane_bas_piece) / 2 ; % nombre d'lments de poudre de part et d'autre de la partie basse de la pice (Y)
     nb_elm_hauteur_bas_piece = hauteur_bas_piece / layer ; % nombre d'lments hauteur partie basse de la pice (Y)

     lambda(1:nb_elm_poudre_bas_piece,1:nb_elm_hauteur_bas_piece) = lambda_poudre ; % partie droite du domaine avec de la poudre
     lambda(nely-nb_elm_poudre_bas_piece+1:nely,1:nb_elm_hauteur_bas_piece) = lambda_poudre ; % partie gauche du domaine avec de la poudre

     % partie haute Y

     nb_elm_titane_Y = nb_elm_titane_bas_piece/2 ;
   
     for i = nb_elm_hauteur_bas_piece+1:1:nelx
    
       nb_elm_poudre_interieur_Y = round(tand(20)*(i-nb_elm_hauteur_bas_piece)) ;
     
       lambda(1:nely,i) = lambda_poudre ; % initialisation de la couche : poudre sur toute la couche
       lambda(nely/2+nb_elm_poudre_interieur_Y+1:nely/2+nb_elm_poudre_interieur_Y+nb_elm_titane_Y,i) = lambda_titane ; % bras titane droite
       lambda(nely/2-nb_elm_poudre_interieur_Y-nb_elm_titane_Y+1:nely/2-nb_elm_poudre_interieur_Y,i) = lambda_titane ; % bras titane gauche
    
     end
     
  end
  
  if FORME == 2 % PYRAMIDE

  largeur_haut_piece = 20 ; % largeur en partie haute pice (pyramide)  fabriquer (mm)
  nb_elm_titane_haut_piece = largeur_haut_piece/layer ; % nb d'lments en partie haute pice (pyramide)  fabriquer (mm)

    for i = 1:1:nelx
   
      nb_elm_titane_pyramide = round(tand(3)*(nelx-i))+ nb_elm_titane_haut_piece/2 ; 
        
      lambda(1:nely,i) = lambda_poudre ; % initialisation de la couche : poudre sur toute la couche
      lambda(nely/2+1:nely/2+nb_elm_titane_pyramide,i) = lambda_titane ; % partie centrale droite en titane sur la couche
      lambda(nely/2-nb_elm_titane_pyramide+1:nely/2,i) = lambda_titane ; % partie centrale gauche en titane sur la couche
    
    end
    
  end
  
largeur_parois = 19 ; % paisseur des parois (mm)

nb_elm_parois = largeur_parois / layer ; % nombre d'lments composants chaque paroi

lambda(1:nb_elm_parois,1:nelx) = lambda_parois ; % partie droite (19 mm) du domaine en tant que paroi
lambda(nely-nb_elm_parois+1:nely,1:nelx) = lambda_parois ; % partie gauche (19 mm) du domaine en tant que paroi

% REPRESENTATION GRAPHIQUE DE LA REPARTITION DES "LAMBDAS"

fig = figure('Name','Mapping lambda','NumberTitle','on')
hold on
colormap(jet);
contourf(lambda);
colorbar ;
view (-90,90) ; % inversion des axes
set(gca,'YDir','reverse') ; % retournement de l'axe Y
saveas(fig,'lambdas');

%% MATRICES ELEMENTAIRES

% MATRICE DE CONDUCTIVITE THERMIQUE ELEMENTAIRE ( / t & lambda)

KE = [ 2/3  -1/6  -1/3  -1/6;
      -1/6   2/3  -1/6  -1/3;
      -1/3  -1/6   2/3  -1/6;
      -1/6  -1/3  -1/6   2/3;];
  
% MATRICES DE CONVECTION THERMIQUE ELEMENTAIRE ( / t & h & L/2)

% AIR FORCE 

K_CONV_HAUT = [ 0   0    0   0;
                0  2/3  1/3  0;
                0  1/3  2/3  0;
                0   0    0   0;];

% AIR NATUREL (LATERAL DROIT)

K_CONV_LAT_DROIT = [ 2/3  1/3  0  0 ;
                     1/3  2/3  0  0 ;
                      0    0   0  0 ;
                      0    0   0  0 ;];
       
% AIR NATUREL (LATERAL GAUCHE)

K_CONV_LAT_GAUCHE = [ 0  0   0    0  ;
                      0  0   0    0  ;
                      0  0  2/3  1/3 ;
                      0  0  1/3  2/3 ;];
                  
%% DETERMINATION DES NOEUDS FIXES / LIBRES

largeur_joint = 1 ; % largeur joint entre plateau et paroi (mm)
nb_elm_joint = largeur_joint / layer ; % nombre d'lments composants le joint

alldofs = [1:(nely+1)*(nelx+1)] ; % tous les DOFs
fixeddofs = [nb_elm_parois+nb_elm_joint+1:nely-nb_elm_parois-nb_elm_joint+1] ; % plateau de fabrication = DOFs imposs en T
freedofs = setdiff(alldofs,fixeddofs) ; % DOFs libres  calculer

% CONDITIONS LIMITES (EN TEMPERATURE) SUR LARGEUR DU PLATEAU DE FABRICATION

T(fixeddofs,:) = T_plaque ;

%% ETAT D'AVANCEMENT DE LA PRODUCTION

nelx_piece = round (nelx * RATIO_PIECE / 100) ;

x(1:nely,1:nelx_piece) = 1 ; % partie dj produite
x(1:nely,nelx_piece+1:nelx) = 0 ; % partie pas encore produite

%% MATRICES DES COEFFICIENTS D'ECHANGE PAR CONVECTION DANS LE DOMAINE DISCRETISE (DEPENDANT DU % PRODUIT)

% CONVECTION FORCEE

    h_force(1:nely,1:nelx) = 0 ; % init
    
      if CONV_FORCEE == 1
        
      h_force(1:nely,nelx_piece) = h_argon_force ; % convection force avec flux argon
    
      end
    
% CONVECTION NATURELLE

    h_naturel_gauche(1:nely,1:nelx) = 0 ; % init
    h_naturel_droit(1:nely,1:nelx) = 0 ; % init
    
      if CONV_NAT == 1
        
      h_naturel_gauche(1,1:nelx_piece) = h_air_naturel ; % convection par paroi gauche
      h_naturel_droit(nely,1:nelx_piece) = h_air_naturel ; % convection par paroi droite
    
      end
    
% REPRESENTATION GRAPHIQUE DE LA REPARTITION DES COEFF DE CONVECTION

if CONV_FORCEE == 1

fig = figure('Name','Mapping h force','NumberTitle','on')
hold on
colormap(jet);
contourf(h_force);
colorbar ;
view (-90,90) ; % inversion des axes
set(gca,'YDir','reverse') ; % retournement de l'axe Y
saveas(fig,'hforce');

end

if CONV_NAT == 1

fig = figure('Name','Mapping h naturel gauche','NumberTitle','on')
hold on
colormap(jet);
contourf(h_naturel_gauche);
colorbar ;
view (-90,90) ; % inversion des axes
set(gca,'YDir','reverse') ; % retournement de l'axe Y
saveas(fig,'hnatG');

fig = figure('Name','Mapping h naturel droite','NumberTitle','on')
hold on
colormap(jet);
contourf(h_naturel_droit);
colorbar ;
view (-90,90) ; % inversion des axes
set(gca,'YDir','reverse') ; % retournement de l'axe Y
saveas(fig,'hnatD') ;

end

%% ASSEMBLAGE DE LA MATRICE DE CONDUCTIVITE GLOBALE (Y INCLUS ELEMENTS POUR CONVECTION)
  
I = zeros(nelx*nely*16,1);
J = zeros(nelx*nely*16,1); 
X = zeros(nelx*nely*16,1); 
U = zeros((nely+1)*(nelx+1),1);

ntriplets = 0;

for elx = 1:nelx
    for ely = 1:nely
        n1 = (nely+1)*(elx-1)+ely ;
        n2 = (nely+1)* elx +ely ;
        edof = [n1 n2 n2+1 n1+1] ;
        
        xval = x(ely,elx) ;
        
        lambdaval = lambda(ely,elx) ;
        
        hval_force = h_force(ely,elx);
        hval_naturel_droit = h_naturel_droit(ely,elx);
        hval_naturel_gauche = h_naturel_gauche(ely,elx);
        
        tval = t(ely,elx) ;
        
        for krow = 1:4
            for kcol = 1:4
                ntriplets = ntriplets+1;
                I(ntriplets) = edof(krow);
                J(ntriplets) = edof(kcol);
                
                X(ntriplets) = xval * ( lambdaval*tval/1000*KE(krow,kcol) + hval_force*tval/1000*K_CONV_HAUT(krow,kcol)*layer/2000 + hval_naturel_gauche*tval/1000*K_CONV_LAT_GAUCHE(krow,kcol)*layer/2000 + hval_naturel_droit*tval/1000*K_CONV_LAT_DROIT(krow,kcol)*layer/2000 ) ;
               
            end
        end
    end
end

K = sparse(I,J,X,(nelx+1)*(nely+1),(nelx+1)*(nely+1));   
   
%% CHARGES THERMIQUES (REELLES & FICTIVES) APPLIQUEES

P = zeros((nely+1)*(nelx+1),1) ; % initialisation de la matrice de source / charge thermique
P_LASER = zeros((nely+1)*(nelx+1),1) ; % initialisation de la matrice de source / charge thermique LASER
P_CONV_FORCEE = zeros((nely+1)*(nelx+1),1) ; % initialisation de la matrice de source / charge thermique fictive de convection forcee
P_CONV_NAT_GAUCHE = zeros((nely+1)*(nelx+1),1) ; % initialisation de la matrice de source / charge thermique fictive de convection naturelle de la paroi GAUCHE
P_CONV_NAT_DROITE = zeros((nely+1)*(nelx+1),1) ; % initialisation de la matrice de source / charge thermique fictive de convection naturelle de la paroi DROITE

% CHARGE THERMIQUE REELLE APPLIQUEE PAR LE LASER

if LASER == 1

charge_therm_totale = 2 ; % puissance totale apporte par le laser (W)

  if FORME == 1 % RECTANGLE
  
  charge_therm_elm = charge_therm_totale / nb_elm_titane ; % puissance par lment apporte par le laser (W)

  [dofs_source_milieu] = finddofs (nelx_piece,nb_elm_poudre+1:nely-nb_elm_poudre,[34],nelx,nely); % noeuds laser centraux
  [dofs_source_gauche] = finddofs (nelx_piece,nely-nb_elm_poudre,[4],nelx,nely); % noeud laser extremit gauche
  [dofs_source_droite] = finddofs (nelx_piece,nb_elm_poudre+1,[3],nelx,nely); % noeud laser extrmit droite

  P_LASER(dofs_source_milieu,1) = charge_therm_elm ; % charge elementaire sur noeuds source centraux
  P_LASER(dofs_source_gauche,1) = charge_therm_elm / 2 ; % demi-charge elementaire sur noeud source extreme gauche
  P_LASER(dofs_source_droite,1) = charge_therm_elm / 2 ; % demi-charge elementaire sur noeud source extreme droite

  % P(dofs_source_milieu,1) = 500 ; % grosse charge sur noeud source milieu (VERIFICATION !!)
  % P(dofs_source_gauche,1) = 500 ; % grosse charge sur noeud source extreme gauche (VERIFICATION !!)
  % P(dofs_source_droite,1) = 500 ; % grosse charge sur noeud source extreme droite (VERIFICATION !!)
  
  end
  
  if FORME == 3 % Y
  
  charge_therm_elm = charge_therm_totale / (nb_elm_titane_Y*2) ; % puissance par lment apporte par le laser (W)
  
    if nelx_piece > nb_elm_hauteur_bas_piece

    nb_elm_poudre_interieur_Y_nelx_piece = round(tand(20)*(nelx_piece-nb_elm_hauteur_bas_piece)) ;
  
    else

    nb_elm_poudre_interieur_Y_nelx_piece = 0 ;

    end

   [dofs_source_milieu_droite] = finddofs (nelx_piece,nely/2+nb_elm_poudre_interieur_Y_nelx_piece+1:nely/2+nb_elm_poudre_interieur_Y_nelx_piece+nb_elm_titane_Y,[34],nelx,nely); % noeuds laser centraux droite
   [dofs_source_gauche_droite] = finddofs (nelx_piece,nely/2+nb_elm_poudre_interieur_Y_nelx_piece+1,[3],nelx,nely); % noeud laser extremit gauche droite
   [dofs_source_droite_droite] = finddofs (nelx_piece,nely/2+nb_elm_poudre_interieur_Y_nelx_piece+nb_elm_titane_Y,[4],nelx,nely); % noeud laser extrmit droite droite

   [dofs_source_milieu_gauche] = finddofs (nelx_piece,nely/2-nb_elm_poudre_interieur_Y_nelx_piece-nb_elm_titane_Y+1:nely/2-nb_elm_poudre_interieur_Y_nelx_piece,[34],nelx,nely); % noeuds laser centraux gauche
   [dofs_source_gauche_gauche] = finddofs (nelx_piece,nely/2-nb_elm_poudre_interieur_Y_nelx_piece-nb_elm_titane_Y+1,[3],nelx,nely); % noeud laser extremit gauche gauche
   [dofs_source_droite_gauche] = finddofs (nelx_piece,nely/2-nb_elm_poudre_interieur_Y_nelx_piece,[4],nelx,nely); % noeud laser extrmit droite gauche
 
    if nb_elm_poudre_interieur_Y_nelx_piece == 0
        
    P_LASER(dofs_source_milieu_droite,1) = charge_therm_elm ;   % charge elementaire sur noeuds source centraux droite
    P_LASER(dofs_source_milieu_gauche,1) = charge_therm_elm ;   % charge elementaire sur noeuds source centraux gauche
    P_LASER(dofs_source_droite_droite,1) = charge_therm_elm / 2 ; % demi-charge elementaire sur noeud source extreme droite droite
    P_LASER(dofs_source_gauche_gauche,1) = charge_therm_elm / 2 ; % demi-charge elementaire sur noeud source extreme gauche gauche

    else
        
    P_LASER(dofs_source_milieu_droite,1) = charge_therm_elm ; % charge elementaire sur noeuds source centraux droite
    P_LASER(dofs_source_gauche_droite,1) = charge_therm_elm / 2 ; % demi-charge elementaire sur noeud source extreme gauche droite
    P_LASER(dofs_source_droite_droite,1) = charge_therm_elm / 2 ; % demi-charge elementaire sur noeud source extreme droite droite
  
    P_LASER(dofs_source_milieu_gauche,1) = charge_therm_elm ; % charge elementaire sur noeuds source centraux gauche
    P_LASER(dofs_source_gauche_gauche,1) = charge_therm_elm / 2 ; % demi-charge elementaire sur noeud source extreme gauche gauche
    P_LASER(dofs_source_droite_gauche,1) = charge_therm_elm / 2 ; % demi-charge elementaire sur noeud source extreme droite gauche
  
    end
    
  end
  
  if FORME == 2 % PYRAMIDE
  
  nb_elm_titane_pyramide = round(tand(3)*(nelx-nelx_piece))*2+ nb_elm_titane_haut_piece ; % nb d'lments de la couche en production
  
  charge_therm_elm = charge_therm_totale / nb_elm_titane_pyramide  ; % puissance par lment apporte par le laser (W)
  
  [dofs_source_milieu] = finddofs (nelx_piece,nely/2-nb_elm_titane_pyramide/2+1:nely/2+nb_elm_titane_pyramide/2,[34],nelx,nely); % noeuds laser centraux
  [dofs_source_gauche] = finddofs (nelx_piece,nely/2-nb_elm_titane_pyramide/2+1,[3],nelx,nely); % noeud laser extremit gauche
  [dofs_source_droite] = finddofs (nelx_piece,nely/2+nb_elm_titane_pyramide/2,[4],nelx,nely); % noeud laser extrmit droite droite
  
  P_LASER(dofs_source_milieu,1) = charge_therm_elm ;     % charge elementaire sur noeuds source centraux
  P_LASER(dofs_source_gauche,1) = charge_therm_elm / 2 ; % demi-charge elementaire sur noeud source extreme gauche
  P_LASER(dofs_source_droite,1) = charge_therm_elm / 2 ; % demi-charge elementaire sur noeud source extreme droite
  
  % P(dofs_source_milieu,1) = 500 ; % grosse charge sur noeud source milieu (VERIFICATION !!)
  % P(dofs_source_gauche,1) = 500 ; % grosse charge sur noeud source extreme gauche (VERIFICATION !!)
  % P(dofs_source_droite,1) = 500 ; % grosse charge sur noeud source extreme droite (VERIFICATION !!)
  
  end
  
end

% CHARGES (FICTIVES) POUR LA MODELISATION DE LA CONVECTION

% CONVECTION FORCEE

if CONV_FORCEE == 1
      
[dofs_source_conv_forcee] = finddofs (nelx_piece,1:nely,[34],nelx,nely) ;
[dofs_source_conv_forcee_ext_gauche] = finddofs (nelx_piece,1,[3],nelx,nely) ;
[dofs_source_conv_forcee_ext_droite] = finddofs (nelx_piece,nely,[4],nelx,nely) ;

P_CONV_FORCEE(dofs_source_conv_forcee,1) = T_argon*layer/1000*t(nely/2,nelx_piece)/1000*h_argon_force ;
P_CONV_FORCEE(dofs_source_conv_forcee_ext_gauche,1) = T_argon*layer/2000*t(nely/2,nelx_piece)/1000*h_argon_force ;
P_CONV_FORCEE(dofs_source_conv_forcee_ext_droite,1) = T_argon*layer/2000*t(nely/2,nelx_piece)/1000*h_argon_force ;

end

if CONV_NAT == 1
    
[dofs_source_conv_naturel_gauche] = finddofs (2:nelx_piece-1,1,[13],nelx,nely) ;
[dofs_source_conv_naturel_gauche_ext_bas] = finddofs (1,1,[1],nelx,nely) ;
[dofs_source_conv_naturel_gauche_ext_haut] = finddofs (nelx_piece,1,[3],nelx,nely) ;

P_CONV_NAT_GAUCHE(dofs_source_conv_naturel_gauche,1) = T_air*layer/2000*t(1,1:nelx_piece-1)/1000*h_air_naturel + T_air*layer/2000*t(1,2:nelx_piece)/1000*h_air_naturel ;
P_CONV_NAT_GAUCHE(dofs_source_conv_naturel_gauche_ext_bas,1) = T_air*layer/2000*t(1,1)/1000*h_air_naturel ;
P_CONV_NAT_GAUCHE(dofs_source_conv_naturel_gauche_ext_haut,1) = T_air*layer/2000*t(1,nelx_piece)/1000*h_air_naturel ;

[dofs_source_conv_naturel_droite] = finddofs (2:nelx_piece-1,nely,[24],nelx,nely) ;
[dofs_source_conv_naturel_droite_ext_bas] = finddofs (1,nely,[2],nelx,nely) ;
[dofs_source_conv_naturel_droite_ext_haut] = finddofs (nelx_piece,nely,[4],nelx,nely) ;

P_CONV_NAT_DROITE(dofs_source_conv_naturel_droite,1) = T_air*layer/2000*t(1,1:nelx_piece-1)/1000*h_air_naturel + T_air*layer/2000*t(1,2:nelx_piece)/1000*h_air_naturel ;
P_CONV_NAT_DROITE(dofs_source_conv_naturel_droite_ext_bas,1) = T_air*layer/2000*t(1,1)/1000*h_air_naturel ;
P_CONV_NAT_DROITE(dofs_source_conv_naturel_droite_ext_haut,1) = T_air*layer/2000*t(1,nelx_piece)/1000*h_air_naturel ;

end

P  = P_LASER + P_CONV_FORCEE + P_CONV_NAT_GAUCHE + P_CONV_NAT_DROITE ;

% REPRESENTATION GRAPHIQUE DU CHAMP DE CHARGES THERMIQUES (REELLES & FICTIVES)

P_ToPlot = reshape(P,(nely+1),(nelx+1)) ;

fig = figure('Name','Champ de charges thermiques','NumberTitle','on')
hold on 
colormap(jet) ;
contourf(P_ToPlot) ;
colorbar ;
view (-90,90) ; % inversion des axes
set(gca,'YDir','reverse') ; % retournement de l'axe Y
saveas(fig,'charges_th') ;

%% CALCUL DU CHAMP DE TEMPERATURE

T(freedofs,:) = K(freedofs,freedofs)\(P(freedofs,:)-K(freedofs,fixeddofs)*T(fixeddofs,:)) ;

% REPRESENTATION GRAPHIQUE DU CHAMP DE TEMPERATURE

T_ToPlot = reshape(T,(nely+1),(nelx+1)) ;

fig = figure('Name','Champ de tempratures','NumberTitle','on')
hold on 
colormap(jet) ;
contourf(T_ToPlot) ;
colorbar ;
view (-90,90) ; % inversion des axes
set(gca,'YDir','reverse') ; % retournement de l'axe Y
saveas(fig,'tempratures') ;

%% FLUX DE CHALEUR

Bx = [ -1/4  1/4  1/4 -1/4];
By = [ -1/4 -1/4  1/4  1/4];
   
PHI_X(1:nely,1:nelx) = 0 ;
PHI_Y(1:nely,1:nelx) = 0 ;

for elx = 1:nelx
    for ely = 1:nely
        
        [dofs_T1] = finddofs (elx,ely,[1],nelx,nely) ;
        [dofs_T2] = finddofs (elx,ely,[3],nelx,nely) ;
        [dofs_T3] = finddofs (elx,ely,[4],nelx,nely) ;
        [dofs_T4] = finddofs (elx,ely,[2],nelx,nely) ;

        TE = zeros(1,4);
        
        TE1 =  T(dofs_T1);
        TE2 =  T(dofs_T2);
        TE3 =  T(dofs_T3);
        TE4 =  T(dofs_T4);

        TE = [TE1 TE2 TE3 TE4] ;
        TET = transpose (TE) ;
        
        PHI_X(ely,elx) = -lambda(ely,elx) * Bx * TET * 2 / layer * x(ely,elx) ;
        PHI_Y(ely,elx) = -lambda(ely,elx) * By * TET * 2 / layer * x(ely,elx);
         
    end
end
        
% REPRESENTATION GRAPHIQUE FLUX DE CHALEUR

[x,y] = meshgrid(1:1:nelx,1:1:nely) ;

u = PHI_X ;
v = PHI_Y ;

fig = figure('Name','Flux de chaleur','NumberTitle','off')
hold on
quiver(x,y,u,v)
view (-90,90) ; % inversion des axes
set(gca,'YDir','reverse') ; % retournement de l'axe Y
saveas(fig,'flux') ;

%% FINALISATION

toc % fin temps de calcul