%% INITIALISATION

clear all ;
close all ;

tic % dbut temps de calcul

warning('off','MATLAB:singularMatrix') ; % dsactivation du message d'erreur rcurrent

% Initialisation d'une video 

% vidObj = VideoWriter('Movie.avi');
% vidObj.FrameRate=5;
% open(vidObj);

% DIMENSIONS 2D DE LA BUILDING BOX

h = 200 ; % hauteur pice  fabriquer (mm)
l = 250+2*19 ; % largeur building box(mm)

% EPAISSEUR DE COUCHE DE PRODUCTION

layer = 1 ; % taille lement carr (mm)

% DISCRETISATION DU DOMAINE 2D

nelx = h / layer ; % nombre d'lments suivant X (hauteur)
nely = l / layer ; % nombre d'lments suivant Y (largeur)

% TEMPERATURE DE PLAQUE (POUR CONDITIONS LIMITES EN TEMPERATURE)

T_plaque = 95 ; %C

%% DISCRETISATION TEMPORELLE

delta_t = 0.1 ;

%% CHOIX INITIAUX DE BASE PAR L'UTILISATEUR

% CHOIX DE LA PIECE A SIMULER

prompt = 'RECTANGLE (1) - PYRAMIDE (2) - Y (3)   ' ;
FORME = input(prompt) ;

% CHOIX DU RATIO DE PRODUCTION DE LA PIECE

prompt = 'COUCHE DE PRODUCTION INITIALE ?   ' ;
nelx_piece_initial = input(prompt) ;

prompt = 'COUCHE DE PRODUCTION FINALE ?   ' ;
nelx_piece_final = input(prompt) ;

% NOMBRE DE CYCLES PAR COUCHE

prompt = 'NOMBRE DE CYCLES PAR COUCHE ?   ' ;
nb_cycles = input(prompt) ;

% CHOIX CONDUCTION

prompt = 'LASER ? (1) OUI    (0) NON    ' ;
LASER = input(prompt) ;

% CHOIX CONVECTION FORCEE

prompt = 'CONVECTION FORCEE ? (1) OUI    (0) NON    ' ;
CONV_FORCEE = input(prompt) ;

% CHOIX CONVECTION NATURELLE

prompt = 'CONVECTION NATURELLE ? (1) OUI    (0) NON    ' ;
CONV_NAT = input(prompt) ;

%% EPAISSEUR DES PIECES MODELES

Ep_ref = 10 ; % (mm)

Ep(1:nely,1:nelx) = 0 ; % initialisation de la matrice des paisseurs

  if FORME == 1 % RECTANGLE
  
    Ep(1:nely,1:nelx) = Ep_ref ; % matrice des paisseurs de pice (RECTANGLE)
    %Ep(1,1) = Ep_ref - 0.0000000001 ; % point modifi pour des raisons d'affichage
  
  end
  
  if FORME == 3 % Y
  
    Ep(1:nely,1:nelx) = Ep_ref ; % matrice des paisseurs de pice (Y)
    %Ep(1,1) = Ep_ref - 0.0000000001 ; % point modifi pour des raisons d'affichage
  
  end 

  if FORME == 2 % PYRAMIDE
  
      for i = 1:1:nelx
        
      Ep(1:nely,i) = round(tand(3)*(nelx-i),2)*2*layer + Ep_ref ; % remplissage matrice des paisseurs de pice (PYRAMIDE)
      
      end
      
  end
  
  % REPRESENTATION GRAPHIQUE DE LA REPARTITION DES "EPAISSEURS"

  %   fig = figure('Name','Mapping paisseurs','NumberTitle','on')
  %   hold on
  %   colormap(jet);
  %   contourf(Ep);
  %   colorbar ;
  %   view (-90,90) ; % inversion des axes
  %   set(gca,'YDir','reverse') ; % retournement de l'axe Y
  %   saveas(fig,'paisseurs');
  
%% CARACTERISTIQUES THERMIQUES DES MATERIAUX NON VARIABLES EN FONCTION DE LA TEMPERATURE

% rho (transitoire)

rho_titane = 4430 ; % (kg/m3)
rho_poudre = 4430 ; % (kg/m3)
rho_parois = 7900 ; % (kg/m3)

% coefficients d'change par convection

 % convection forcee (argon)
 
   h_argon_force = 25 ; % coeff change par convection force (W/(m2.K))
   T_argon = 40 ; % temperature argon (C)
 
 % convection naturelle (air ambiant)

   h_air_naturel = 5 ; % coeff change par convection naturelle (W/(m2.K))
   T_air = 25 ; % temperature air ambiant (C)

%% MATRICES DES COEFFICIENTS DE MASSE VOLUMIQUE (rho) DANS LE DOMAINE DISCRETISE

largeur_ref = 20 ; % largeur de rfrence des pices modles

rho(1:nely,1:nelx) = rho_titane ; % initialisation du domaine : tout le domaine est en titane

  if FORME == 1 % RECTANGLE

    largeur_piece = largeur_ref ; % largeur pice (rectangulaire)  fabriquer (mm)

    nb_elm_titane = largeur_piece / layer ; % nombre d'lments de la pice (rectangulaire) en titane
    nb_elm_poudre = (nely - nb_elm_titane) / 2 ; % nombre d'lments de poudre de part et d'autre de la pice

    rho(1:nb_elm_poudre,1:nelx) = rho_poudre ; % partie droite du domaine avec de la poudre
    rho(nely-nb_elm_poudre+1:nely,1:nelx) = rho_poudre ; % partie gauche du domaine avec de la poudre

  end
  
  if FORME == 3 % Y

     % partie basse Y

     largeur_bas_piece = largeur_ref ; % largeur bas de la pice (Y)  fabriquer (mm)
     hauteur_bas_piece = 50 ; % hauteur bas de la pice (Y)  fabriquer (mm)

     nb_elm_titane_bas_piece = largeur_bas_piece / layer ; % nombre d'lments bas de la pice (Y)  fabriquer (mm)
     nb_elm_poudre_bas_piece = (nely - nb_elm_titane_bas_piece) / 2 ; % nombre d'lments de poudre de part et d'autre de la partie basse de la pice (Y)
     nb_elm_hauteur_bas_piece = hauteur_bas_piece / layer ; % nombre d'lments hauteur partie basse de la pice (Y)

     rho(1:nb_elm_poudre_bas_piece,1:nb_elm_hauteur_bas_piece) = rho_poudre ; % partie droite du domaine avec de la poudre
     rho(nely-nb_elm_poudre_bas_piece+1:nely,1:nb_elm_hauteur_bas_piece) = rho_poudre ; % partie gauche du domaine avec de la poudre

     % partie haute Y

     nb_elm_titane_Y = nb_elm_titane_bas_piece/2 ;
   
     for i = nb_elm_hauteur_bas_piece+1:1:nelx
    
       nb_elm_poudre_interieur_Y = round(tand(20)*(i-nb_elm_hauteur_bas_piece)) ;
     
       rho(1:nely,i) = rho_poudre ; % initialisation de la couche : poudre sur toute la couche
       rho(nely/2+nb_elm_poudre_interieur_Y+1:nely/2+nb_elm_poudre_interieur_Y+nb_elm_titane_Y,i) = rho_titane ; % bras titane droite
       rho(nely/2-nb_elm_poudre_interieur_Y-nb_elm_titane_Y+1:nely/2-nb_elm_poudre_interieur_Y,i) = rho_titane ; % bras titane gauche
    
     end
     
  end
  
  if FORME == 2 % PYRAMIDE

  largeur_haut_piece = largeur_ref ; % largeur en partie haute pice (pyramide)  fabriquer (mm)
  nb_elm_titane_haut_piece = largeur_haut_piece/layer ; % nb d'lments en partie haute pice (pyramide)  fabriquer (mm)

    for i = 1:1:nelx
   
      nb_elm_titane_pyramide = round(tand(3)*(nelx-i))+ nb_elm_titane_haut_piece/2 ; 
        
      rho(1:nely,i) = rho_poudre ; % initialisation de la couche : poudre sur toute la couche
      rho(nely/2+1:nely/2+nb_elm_titane_pyramide,i) = rho_titane ; % partie centrale droite en titane sur la couche
      rho(nely/2-nb_elm_titane_pyramide+1:nely/2,i) = rho_titane ; % partie centrale gauche en titane sur la couche
    
    end
    
  end
  
largeur_parois = 19.0 ; % paisseur des parois (mm)

nb_elm_parois = largeur_parois / layer ; % nombre d'lments composants chaque paroi

rho(1:nb_elm_parois,1:nelx) = rho_parois ; % partie droite (19 mm) du domaine en tant que paroi
rho(nely-nb_elm_parois+1:nely,1:nelx) = rho_parois ; % partie gauche (19 mm) du domaine en tant que paroi

%% MATRICES ELEMENTAIRES

% MATRICE DE CONDUCTIVITE THERMIQUE ELEMENTAIRE ( / t & lambda)

KE = [ 2/3  -1/6  -1/3  -1/6;
      -1/6   2/3  -1/6  -1/3;
      -1/3  -1/6   2/3  -1/6;
      -1/6  -1/3  -1/6   2/3;];
  
% MATRICES DE CONVECTION THERMIQUE ELEMENTAIRE ( / t & h & L/2)

% AIR FORCE 

K_CONV_HAUT = [ 0   0    0   0;
                0  2/3  1/3  0;
                0  1/3  2/3  0;
                0   0    0   0;];

% AIR NATUREL (LATERAL DROIT)

K_CONV_LAT_DROIT = [ 2/3  1/3  0  0 ;
                     1/3  2/3  0  0 ;
                      0    0   0  0 ;
                      0    0   0  0 ;];
       
% AIR NATUREL (LATERAL GAUCHE)

K_CONV_LAT_GAUCHE = [ 0  0   0    0  ;
                      0  0   0    0  ;
                      0  0  2/3  1/3 ;
                      0  0  1/3  2/3 ;];
                  
% MATRICE DE CAPACITE THERMIQUE ( / t & rho & Cp & L^2/4)

CpE = [ 4/9 2/9 1/9 2/9;
        2/9 4/9 2/9 1/9;
        1/9 2/9 4/9 2/9;
        2/9 1/9 2/9 4/9;];
                  
%% DETERMINATION DES NOEUDS FIXES / LIBRES

largeur_joint = 1 ; % largeur joint entre plateau et paroi (mm)
nb_elm_joint = largeur_joint / layer ; % nombre d'lments composants le joint

alldofs = [1:(nely+1)*(nelx+1)] ; % tous les DOFs
fixeddofs = [nb_elm_parois+nb_elm_joint+1:nely-nb_elm_parois-nb_elm_joint+1] ; % plateau de fabrication = DOFs imposs en T
freedofs = setdiff(alldofs,fixeddofs) ; % DOFs libres  calculer

% CONDITIONS LIMITES (EN TEMPERATURE) SUR LARGEUR DU PLATEAU DE FABRICATION

T(fixeddofs,:) = T_plaque ;

%% PRODUCTION DE LA PIECE COUCHE / COUCHE DE nelx_piece_initial  nelx_piece_final

iter = 0 ;

% CHAMP T INITIAL

T0(alldofs,:) = T_plaque ;

    for i = 1:1:nelx-nelx_piece_initial
    
    [dofs_vide] = finddofs (nelx_piece_initial+i,1:nely,[34],nelx,nely) ;
    
    T0(dofs_vide,:) = 0 ;
    
    end
    
% REPRESENTATION GRAPHIQUE DU CHAMP DE T INITIAL DE BASE (T0)


% T0_ToPlot = reshape(T0,(nely+1),(nelx+1)) ;
% 
% fig = figure('Name','Champ T initial','NumberTitle','off')
% hold on
% colormap(jet);
% [c,h]=contourf(T0_ToPlot) ;
% set(h,'edgecolor','none') ; % "lissage" du graphique
% cmin=0 ;
% cmax=1000 ;
% caxis([cmin cmax]) ;
% colorbar ;
% 
% view (-90,90) ; % inversion des axes
% set(gca,'YDir','reverse') ; % retournement de l'axe Y
% 
% saveas(fig,'T0');
    
%% EVOLUTION DES DIMENSIONS ET FORME DE LA PIECE EN COURS DE PRODUCTION

for nelx_piece = nelx_piece_initial:1:nelx_piece_final

% CHAMP DE T INITIAL MIS A JOUR AVEC UNE COUCHE EN PLUS A CHAQUE ITERATION !!    
    
if nelx_piece == 1 % on garde le To de base (avant itrations)

end

if nelx_piece == nelx_piece_initial % on garde le To de base (avant itrations) 
    
end

if nelx_piece > nelx_piece_initial % on rajoute une ligne au champ de T prcdent
    
[dofs_couche_precedente] = finddofs (nelx_piece-1,1:nely,[34],nelx,nely) ;
[dofs_couche_prod] = finddofs (nelx_piece,1:nely,[34],nelx,nely) ;
T0(dofs_couche_prod,:) = T0(dofs_couche_precedente,:) ;

end

%% Limitation du champ de T  la hauteur de la pice produite
    
x(1:nely,1:nelx_piece) = 1 ; % partie dj produite
x(1:nely,nelx_piece+1:nelx) = 0 ; % partie pas encore produite

%% MATRICES DE TRANSMISSION + CAPACITE THERMIQUE VARIABLES EN FONCTION DU CHAMP INITIAL

% Calcul des tempratures moyennes & matrices avec lambdas titane et poudre associs par lment

temp_moy_elm(1:nely,1:nelx) = 0 ; % initialisation de la matrice de tempratures moyennes

mat_lambda_titane(1:nely,1:nelx) = 0 ; % initialisation de la matrice de transmission thermique pour le titane
mat_lambda_poudre(1:nely,1:nelx) = 0 ; % initialisation de la matrice de transmission thermique pour le titane

mat_Cp_titane(1:nely,1:nelx) = 0 ; % initialisation de la matrice de capacit thermique pour le titane
mat_Cp_poudre(1:nely,1:nelx) = 0 ; % initialisation de la matrice de capacit thermique pour le titane

for i = 1:1:nelx

    for j = 1:1:nely
    
    [T_1] = finddofs (i,j,[1],nelx,nely) ;
    [T_2] = finddofs (i,j,[2],nelx,nely) ;
    [T_3] = finddofs (i,j,[3],nelx,nely) ;
    [T_4] = finddofs (i,j,[4],nelx,nely) ;
    
    temp_moy_elm(j,i) = ( T0(T_1,:) + T0(T_2,:) + T0(T_3,:) + T0(T_4,:) ) / 4 ;
    
    mat_lambda_titane(j,i) = 6.95757+0.00224*temp_moy_elm(j,i)+(1.69E-5)*temp_moy_elm(j,i)^2-(7.58E-9)*temp_moy_elm(j,i)^3 ; % (W/m.C)
    mat_lambda_poudre(j,i) = 0.9315-0.00339*temp_moy_elm(j,i)+(6.55E-6)*temp_moy_elm(j,i)^2-(1.41E-9)*temp_moy_elm(j,i)^3 ; % (W/m.C)
    lambda_parois = 15 ; % (W/m.C)
    
    mat_Cp_titane(j,i) = (0.54058+(1.02E-4)*temp_moy_elm(j,i)+(1.35E-7)*temp_moy_elm(j,i)^2-(6.50E-11)*temp_moy_elm(j,i)^3)*1000 ; % (J/kg.C)
    mat_Cp_poudre(j,i) = (0.52036-(8.34E-6)*temp_moy_elm(j,i)-(4.46E-7)*temp_moy_elm(j,i)^2+(5.44E-10)*temp_moy_elm(j,i)^3)*1000 ; % (J/kg.C)
    Cp_parois = 500 ; % (J/kg.C)
    
    end

end

% Calcul des mapping lambda et Cp pour les 3 pices modles

largeur_ref = 20 ; % largeur de rfrence des pices modles

lambda(1:nely,1:nelx) = mat_lambda_titane(1:nely,1:nelx) ; % initialisation du domaine lambda : tout le domaine est en titane
Cp(1:nely,1:nelx) = mat_Cp_titane(1:nely,1:nelx) ; % initialisation du domaine Cp : tout le domaine est en titane

  if FORME == 1 % RECTANGLE

    largeur_piece = largeur_ref ; % largeur pice (rectangulaire)  fabriquer (mm)

    nb_elm_titane = largeur_piece / layer ; % nombre d'lments de la pice (rectangulaire) en titane
    nb_elm_poudre = (nely - nb_elm_titane) / 2 ; % nombre d'lments de poudre de part et d'autre de la pice

    lambda(1:nb_elm_poudre,1:nelx) = mat_lambda_poudre(1:nb_elm_poudre,1:nelx) ; % partie droite du domaine avec de la poudre
    lambda(nely-nb_elm_poudre+1:nely,1:nelx) = mat_lambda_poudre(nely-nb_elm_poudre+1:nely,1:nelx) ; % partie gauche du domaine avec de la poudre

    Cp(1:nb_elm_poudre,1:nelx) = mat_Cp_poudre(1:nb_elm_poudre,1:nelx) ; % partie droite du domaine avec de la poudre
    Cp(nely-nb_elm_poudre+1:nely,1:nelx) = mat_Cp_poudre(nely-nb_elm_poudre+1:nely,1:nelx) ; % partie gauche du domaine avec de la poudre
    
  end
  
  if FORME == 3 % Y

     % partie basse Y

     largeur_bas_piece = largeur_ref ; % largeur bas de la pice (Y)  fabriquer (mm)
     hauteur_bas_piece = 50 ; % hauteur bas de la pice (Y)  fabriquer (mm)

     nb_elm_titane_bas_piece = largeur_bas_piece / layer ; % nombre d'lments bas de la pice (Y)  fabriquer (mm)
     nb_elm_poudre_bas_piece = (nely - nb_elm_titane_bas_piece) / 2 ; % nombre d'lments de poudre de part et d'autre de la partie basse de la pice (Y)
     nb_elm_hauteur_bas_piece = hauteur_bas_piece / layer ; % nombre d'lments hauteur partie basse de la pice (Y)

     lambda(1:nb_elm_poudre_bas_piece,1:nb_elm_hauteur_bas_piece) = mat_lambda_poudre(1:nb_elm_poudre_bas_piece,1:nb_elm_hauteur_bas_piece) ; % partie droite du domaine avec de la poudre
     lambda(nely-nb_elm_poudre_bas_piece+1:nely,1:nb_elm_hauteur_bas_piece) = mat_lambda_poudre(nely-nb_elm_poudre_bas_piece+1:nely,1:nb_elm_hauteur_bas_piece) ; % partie gauche du domaine avec de la poudre
     
     Cp(1:nb_elm_poudre_bas_piece,1:nb_elm_hauteur_bas_piece) = mat_Cp_poudre(1:nb_elm_poudre_bas_piece,1:nb_elm_hauteur_bas_piece) ; % partie droite du domaine avec de la poudre
     Cp(nely-nb_elm_poudre_bas_piece+1:nely,1:nb_elm_hauteur_bas_piece) = mat_Cp_poudre(nely-nb_elm_poudre_bas_piece+1:nely,1:nb_elm_hauteur_bas_piece) ; % partie gauche du domaine avec de la poudre

     % partie haute Y

     nb_elm_titane_Y = nb_elm_titane_bas_piece/2 ;
   
     for i = nb_elm_hauteur_bas_piece+1:1:nelx
    
       nb_elm_poudre_interieur_Y = round(tand(20)*(i-nb_elm_hauteur_bas_piece)) ;
     
       lambda(1:nely,i) = mat_lambda_poudre(1:nely,i) ; % initialisation de la couche : poudre sur toute la couche
       lambda(nely/2+nb_elm_poudre_interieur_Y+1:nely/2+nb_elm_poudre_interieur_Y+nb_elm_titane_Y,i) = mat_lambda_titane(nely/2+nb_elm_poudre_interieur_Y+1:nely/2+nb_elm_poudre_interieur_Y+nb_elm_titane_Y,i) ; % bras titane droite
       lambda(nely/2-nb_elm_poudre_interieur_Y-nb_elm_titane_Y+1:nely/2-nb_elm_poudre_interieur_Y,i) = mat_lambda_titane(nely/2-nb_elm_poudre_interieur_Y-nb_elm_titane_Y+1:nely/2-nb_elm_poudre_interieur_Y,i) ; % bras titane gauche
       
       Cp(1:nely,i) = mat_Cp_poudre(1:nely,i) ; % initialisation de la couche : poudre sur toute la couche
       Cp(nely/2+nb_elm_poudre_interieur_Y+1:nely/2+nb_elm_poudre_interieur_Y+nb_elm_titane_Y,i) = mat_Cp_titane(nely/2+nb_elm_poudre_interieur_Y+1:nely/2+nb_elm_poudre_interieur_Y+nb_elm_titane_Y,i) ; % bras titane droite
       Cp(nely/2-nb_elm_poudre_interieur_Y-nb_elm_titane_Y+1:nely/2-nb_elm_poudre_interieur_Y,i) = mat_Cp_titane(nely/2-nb_elm_poudre_interieur_Y-nb_elm_titane_Y+1:nely/2-nb_elm_poudre_interieur_Y,i) ; % bras titane gauche
    
     end
     
  end
  
  if FORME == 2 % PYRAMIDE

  largeur_haut_piece = largeur_ref ; % largeur en partie haute pice (pyramide)  fabriquer (mm)
  nb_elm_titane_haut_piece = largeur_haut_piece/layer ; % nb d'lments en partie haute pice (pyramide)  fabriquer (mm)

    for i = 1:1:nelx
   
      nb_elm_titane_pyramide = round(tand(3)*(nelx-i))+ nb_elm_titane_haut_piece/2 ; 
        
      lambda(1:nely,i) = mat_lambda_poudre(1:nely,i) ; % initialisation de la couche : poudre sur toute la couche
      lambda(nely/2+1:nely/2+nb_elm_titane_pyramide,i) = mat_lambda_titane(nely/2+1:nely/2+nb_elm_titane_pyramide,i) ; % partie centrale droite en titane sur la couche
      lambda(nely/2-nb_elm_titane_pyramide+1:nely/2,i) = mat_lambda_titane(nely/2-nb_elm_titane_pyramide+1:nely/2,i) ; % partie centrale gauche en titane sur la couche
    
      Cp(1:nely,i) = mat_Cp_poudre(1:nely,i) ; % initialisation de la couche : poudre sur toute la couche
      Cp(nely/2+1:nely/2+nb_elm_titane_pyramide,i) = mat_Cp_titane(nely/2+1:nely/2+nb_elm_titane_pyramide,i) ; % partie centrale droite en titane sur la couche
      Cp(nely/2-nb_elm_titane_pyramide+1:nely/2,i) = mat_Cp_titane(nely/2-nb_elm_titane_pyramide+1:nely/2,i) ; % partie centrale gauche en titane sur la couche
      
    end
    
  end
  
largeur_parois = 19.0 ; % paisseur des parois (mm)

nb_elm_parois = largeur_parois / layer ; % nombre d'lments composants chaque paroi

lambda(1:nb_elm_parois,1:nelx) = lambda_parois ; % partie droite (19 mm) du domaine en tant que paroi
lambda(nely-nb_elm_parois+1:nely,1:nelx) = lambda_parois ; % partie gauche (19 mm) du domaine en tant que paroi

Cp(1:nb_elm_parois,1:nelx) = Cp_parois ; % partie droite (19 mm) du domaine en tant que paroi
Cp(nely-nb_elm_parois+1:nely,1:nelx) = Cp_parois ; % partie gauche (19 mm) du domaine en tant que paroi

%% MATRICES DES COEFFICIENTS D'ECHANGE PAR CONVECTION DANS LE DOMAINE DISCRETISE (DEPENDANT DU % PRODUIT)

% CONVECTION FORCEE

    h_force(1:nely,1:nelx) = 0 ; % init
    
      if CONV_FORCEE == 1
        
      h_force(1:nely,nelx_piece) = h_argon_force ; % convection force avec flux argon
    
      end
    
% CONVECTION NATURELLE

    h_naturel_gauche(1:nely,1:nelx) = 0 ; % init
    h_naturel_droit(1:nely,1:nelx) = 0 ; % init
    
      if CONV_NAT == 1
        
      h_naturel_gauche(1,1:nelx_piece) = h_air_naturel ; % convection par paroi gauche
      h_naturel_droit(nely,1:nelx_piece) = h_air_naturel ; % convection par paroi droite
    
      end
      
%% ASSEMBLAGE DE LA MATRICE DE CONDUCTIVITE GLOBALE (Y INCLUS ELEMENTS POUR CONVECTION)
  
I = zeros(nelx*nely*16,1);
J = zeros(nelx*nely*16,1); 
X = zeros(nelx*nely*16,1); 
U = zeros((nely+1)*(nelx+1),1);

ntriplets = 0;

for elx = 1:nelx
    for ely = 1:nely
        n1 = (nely+1)*(elx-1)+ely ;
        n2 = (nely+1)* elx +ely ;
        edof = [n1 n2 n2+1 n1+1] ;
        
        xval = x(ely,elx) ;
        
        lambdaval = lambda(ely,elx) ;
        
        hval_force = h_force(ely,elx);
        hval_naturel_droit = h_naturel_droit(ely,elx);
        hval_naturel_gauche = h_naturel_gauche(ely,elx);
        
        Ep_val = Ep(ely,elx) ;
        
        for krow = 1:4
            for kcol = 1:4
                ntriplets = ntriplets+1;
                I(ntriplets) = edof(krow);
                J(ntriplets) = edof(kcol);
                
                X(ntriplets) = xval * ( lambdaval*Ep_val/1000*KE(krow,kcol) + hval_force*Ep_val/1000*K_CONV_HAUT(krow,kcol)*layer/2000 + hval_naturel_gauche*Ep_val/1000*K_CONV_LAT_GAUCHE(krow,kcol)*layer/2000 + hval_naturel_droit*Ep_val/1000*K_CONV_LAT_DROIT(krow,kcol)*layer/2000 ) ;
               
            end
        end
    end
end

K = sparse(I,J,X,(nelx+1)*(nely+1),(nelx+1)*(nely+1)) ;

%% ASSEMBLAGE DE LA MATRICE GLOBALE C
  
I = zeros(nelx*nely*16,1);
J = zeros(nelx*nely*16,1); 
X = zeros(nelx*nely*16,1); 
U = zeros((nely+1)*(nelx+1),1);
ntriplets = 0;

for elx = 1:nelx
    for ely = 1:nely
        n1 = (nely+1)*(elx-1)+ely ;
        n2 = (nely+1)* elx +ely ;
        edof = [n1 n2 n2+1 n1+1] ;
        
        xval = x(ely,elx);
        
        capval = Cp(ely,elx);
        rhoval = rho(ely,elx);
        
        Ep_val = Ep(ely,elx) ;

        for krow = 1:4
            for kcol = 1:4
                ntriplets = ntriplets+1;
                I(ntriplets) = edof(krow);
                J(ntriplets) = edof(kcol);
                X(ntriplets) = xval*CpE(krow,kcol)*Ep_val/1000*rhoval*capval*layer^2/4000000 ;
               
            end
        end
    end
end

C = sparse(I,J,X,(nelx+1)*(nely+1),(nelx+1)*(nely+1));
   
%% CHARGES THERMIQUES (REELLES & FICTIVES) APPLIQUEES

P = zeros((nely+1)*(nelx+1),1) ; % initialisation de la matrice de source / charge thermique
P_LASER = zeros((nely+1)*(nelx+1),1) ; % initialisation de la matrice de source / charge thermique LASER
P_CONV_FORCEE = zeros((nely+1)*(nelx+1),1) ; % initialisation de la matrice de source / charge thermique fictive de convection forcee
P_CONV_NAT_GAUCHE = zeros((nely+1)*(nelx+1),1) ; % initialisation de la matrice de source / charge thermique fictive de convection naturelle de la paroi GAUCHE
P_CONV_NAT_DROITE = zeros((nely+1)*(nelx+1),1) ; % initialisation de la matrice de source / charge thermique fictive de convection naturelle de la paroi DROITE

% CHARGE THERMIQUE REELLE APPLIQUEE PAR LE LASER

if LASER == 1

charge_therm_totale = 350 ; % puissance totale apporte par le laser (W)

  if FORME == 1 % RECTANGLE
  
  charge_therm_elm = charge_therm_totale / nb_elm_titane ; % puissance par lment apporte par le laser (W)

  [dofs_source_milieu] = finddofs (nelx_piece,nb_elm_poudre+1:nely-nb_elm_poudre,[34],nelx,nely); % noeuds laser centraux
  [dofs_source_gauche] = finddofs (nelx_piece,nely-nb_elm_poudre,[4],nelx,nely); % noeud laser extremit gauche
  [dofs_source_droite] = finddofs (nelx_piece,nb_elm_poudre+1,[3],nelx,nely); % noeud laser extrmit droite

  P_LASER(dofs_source_milieu,1) = charge_therm_elm ; % charge elementaire sur noeuds source centraux
  P_LASER(dofs_source_gauche,1) = charge_therm_elm / 2 ; % demi-charge elementaire sur noeud source extreme gauche
  P_LASER(dofs_source_droite,1) = charge_therm_elm / 2 ; % demi-charge elementaire sur noeud source extreme droite
  
  end
  
  if FORME == 3 % Y
  
  charge_therm_elm = charge_therm_totale / (nb_elm_titane_Y*2) ; % puissance par lment apporte par le laser (W)
  
    if nelx_piece > nb_elm_hauteur_bas_piece

    nb_elm_poudre_interieur_Y_nelx_piece = round(tand(20)*(nelx_piece-nb_elm_hauteur_bas_piece)) ;
  
    else

    nb_elm_poudre_interieur_Y_nelx_piece = 0 ;

    end

   [dofs_source_milieu_droite] = finddofs (nelx_piece,nely/2+nb_elm_poudre_interieur_Y_nelx_piece+1:nely/2+nb_elm_poudre_interieur_Y_nelx_piece+nb_elm_titane_Y,[34],nelx,nely); % noeuds laser centraux droite
   [dofs_source_gauche_droite] = finddofs (nelx_piece,nely/2+nb_elm_poudre_interieur_Y_nelx_piece+1,[3],nelx,nely); % noeud laser extremit gauche droite
   [dofs_source_droite_droite] = finddofs (nelx_piece,nely/2+nb_elm_poudre_interieur_Y_nelx_piece+nb_elm_titane_Y,[4],nelx,nely); % noeud laser extrmit droite droite

   [dofs_source_milieu_gauche] = finddofs (nelx_piece,nely/2-nb_elm_poudre_interieur_Y_nelx_piece-nb_elm_titane_Y+1:nely/2-nb_elm_poudre_interieur_Y_nelx_piece,[34],nelx,nely); % noeuds laser centraux gauche
   [dofs_source_gauche_gauche] = finddofs (nelx_piece,nely/2-nb_elm_poudre_interieur_Y_nelx_piece-nb_elm_titane_Y+1,[3],nelx,nely); % noeud laser extremit gauche gauche
   [dofs_source_droite_gauche] = finddofs (nelx_piece,nely/2-nb_elm_poudre_interieur_Y_nelx_piece,[4],nelx,nely); % noeud laser extrmit droite gauche
 
    if nb_elm_poudre_interieur_Y_nelx_piece == 0
        
    P_LASER(dofs_source_milieu_droite,1) = charge_therm_elm ;   % charge elementaire sur noeuds source centraux droite
    P_LASER(dofs_source_milieu_gauche,1) = charge_therm_elm ;   % charge elementaire sur noeuds source centraux gauche
    P_LASER(dofs_source_droite_droite,1) = charge_therm_elm / 2 ; % demi-charge elementaire sur noeud source extreme droite droite
    P_LASER(dofs_source_gauche_gauche,1) = charge_therm_elm / 2 ; % demi-charge elementaire sur noeud source extreme gauche gauche

    else
        
    P_LASER(dofs_source_milieu_droite,1) = charge_therm_elm ; % charge elementaire sur noeuds source centraux droite
    P_LASER(dofs_source_gauche_droite,1) = charge_therm_elm / 2 ; % demi-charge elementaire sur noeud source extreme gauche droite
    P_LASER(dofs_source_droite_droite,1) = charge_therm_elm / 2 ; % demi-charge elementaire sur noeud source extreme droite droite
  
    P_LASER(dofs_source_milieu_gauche,1) = charge_therm_elm ; % charge elementaire sur noeuds source centraux gauche
    P_LASER(dofs_source_gauche_gauche,1) = charge_therm_elm / 2 ; % demi-charge elementaire sur noeud source extreme gauche gauche
    P_LASER(dofs_source_droite_gauche,1) = charge_therm_elm / 2 ; % demi-charge elementaire sur noeud source extreme droite gauche
  
    end
    
  end
  
  if FORME == 2 % PYRAMIDE
  
  nb_elm_titane_pyramide = round(tand(3)*(nelx-nelx_piece))*2+ nb_elm_titane_haut_piece ; % nb d'lments de la couche en production
  
  charge_therm_elm = charge_therm_totale / nb_elm_titane_pyramide  ; % puissance par lment apporte par le laser (W)
  
  [dofs_source_milieu] = finddofs (nelx_piece,nely/2-nb_elm_titane_pyramide/2+1:nely/2+nb_elm_titane_pyramide/2,[34],nelx,nely); % noeuds laser centraux
  [dofs_source_gauche] = finddofs (nelx_piece,nely/2-nb_elm_titane_pyramide/2+1,[3],nelx,nely); % noeud laser extremit gauche
  [dofs_source_droite] = finddofs (nelx_piece,nely/2+nb_elm_titane_pyramide/2,[4],nelx,nely); % noeud laser extrmit droite droite
  
  P_LASER(dofs_source_milieu,1) = charge_therm_elm ;     % charge elementaire sur noeuds source centraux
  P_LASER(dofs_source_gauche,1) = charge_therm_elm / 2 ; % demi-charge elementaire sur noeud source extreme gauche
  P_LASER(dofs_source_droite,1) = charge_therm_elm / 2 ; % demi-charge elementaire sur noeud source extreme droite
  
  end
  
end

% CHARGES (FICTIVES) POUR LA MODELISATION DE LA CONVECTION

% CONVECTION FORCEE

if CONV_FORCEE == 1
      
[dofs_source_conv_forcee] = finddofs (nelx_piece,1:nely,[34],nelx,nely) ;
[dofs_source_conv_forcee_ext_gauche] = finddofs (nelx_piece,1,[3],nelx,nely) ;
[dofs_source_conv_forcee_ext_droite] = finddofs (nelx_piece,nely,[4],nelx,nely) ;

P_CONV_FORCEE(dofs_source_conv_forcee,1) = T_argon*layer/1000*Ep(nely/2,nelx_piece)/1000*h_argon_force ;
P_CONV_FORCEE(dofs_source_conv_forcee_ext_gauche,1) = T_argon*layer/2000*Ep(nely/2,nelx_piece)/1000*h_argon_force ;
P_CONV_FORCEE(dofs_source_conv_forcee_ext_droite,1) = T_argon*layer/2000*Ep(nely/2,nelx_piece)/1000*h_argon_force ;

end

if CONV_NAT == 1

  if nelx_piece == 1
      
  [dofs_source_conv_naturel_gauche_ext_bas] = finddofs (1,1,[1],nelx,nely) ;
  [dofs_source_conv_naturel_gauche_ext_haut] = finddofs (1,1,[3],nelx,nely) ;
  
  P_CONV_NAT_GAUCHE(dofs_source_conv_naturel_gauche_ext_bas,1) = T_air*layer/2000*Ep(1,1)/1000*h_air_naturel ;
  P_CONV_NAT_GAUCHE(dofs_source_conv_naturel_gauche_ext_haut,1) = T_air*layer/2000*Ep(1,1)/1000*h_air_naturel ;
  
  [dofs_source_conv_naturel_droite_ext_bas] = finddofs (1,nely,[2],nelx,nely) ;
  [dofs_source_conv_naturel_droite_ext_haut] = finddofs (1,nely,[4],nelx,nely) ;
  
  P_CONV_NAT_GAUCHE(dofs_source_conv_naturel_droite_ext_bas,1) = T_air*layer/2000*Ep(1,1)/1000*h_air_naturel ;
  P_CONV_NAT_GAUCHE(dofs_source_conv_naturel_droite_ext_haut,1) = T_air*layer/2000*Ep(1,1)/1000*h_air_naturel ;
  
  end
  
  if nelx_piece == 2
      
  [dofs_source_conv_naturel_gauche] = finddofs (1,1,[3],nelx,nely) ;     
  [dofs_source_conv_naturel_gauche_ext_bas] = finddofs (1,1,[1],nelx,nely) ;
  [dofs_source_conv_naturel_gauche_ext_haut] = finddofs (2,1,[3],nelx,nely) ;
  
  P_CONV_NAT_GAUCHE(dofs_source_conv_naturel_gauche,1) = T_air*layer/2000*Ep(1,1)/1000*h_air_naturel + T_air*layer/2000*Ep(1,2)/1000*h_air_naturel ;
  P_CONV_NAT_GAUCHE(dofs_source_conv_naturel_gauche_ext_bas,1) = T_air*layer/2000*Ep(1,1)/1000*h_air_naturel ;
  P_CONV_NAT_GAUCHE(dofs_source_conv_naturel_gauche_ext_haut,1) = T_air*layer/2000*Ep(1,2)/1000*h_air_naturel ;
  
  [dofs_source_conv_naturel_droite] = finddofs (1,nely,[4],nelx,nely) ;     
  [dofs_source_conv_naturel_droite_ext_bas] = finddofs (1,nely,[2],nelx,nely) ;
  [dofs_source_conv_naturel_droite_ext_haut] = finddofs (2,nely,[4],nelx,nely) ;
  
  P_CONV_NAT_DROITE(dofs_source_conv_naturel_droite,1) = T_air*layer/2000*Ep(1,1)/1000*h_air_naturel + T_air*layer/2000*Ep(1,2)/1000*h_air_naturel ;
  P_CONV_NAT_DROITE(dofs_source_conv_naturel_droite_ext_bas,1) = T_air*layer/2000*Ep(1,1)/1000*h_air_naturel ;
  P_CONV_NAT_DROITE(dofs_source_conv_naturel_droite_ext_haut,1) = T_air*layer/2000*Ep(1,2)/1000*h_air_naturel ;
  
  end
  
  if nelx_piece == 3
      
  [dofs_source_conv_naturel_gauche_milieu_bas] = finddofs (1,1,[3],nelx,nely) ;
  [dofs_source_conv_naturel_gauche_milieu_haut] = finddofs (3,1,[1],nelx,nely) ;
  [dofs_source_conv_naturel_gauche_ext_bas] = finddofs (1,1,[1],nelx,nely) ;
  [dofs_source_conv_naturel_gauche_ext_haut] = finddofs (3,1,[3],nelx,nely) ;
   
  P_CONV_NAT_GAUCHE(dofs_source_conv_naturel_gauche_milieu_bas,1) = T_air*layer/2000*Ep(1,1)/1000*h_air_naturel + T_air*layer/2000*Ep(1,2)/1000*h_air_naturel ;
  P_CONV_NAT_GAUCHE(dofs_source_conv_naturel_gauche_milieu_haut,1) = T_air*layer/2000*Ep(1,2)/1000*h_air_naturel + T_air*layer/2000*Ep(1,3)/1000*h_air_naturel ;
  P_CONV_NAT_GAUCHE(dofs_source_conv_naturel_gauche_ext_bas,1) = T_air*layer/2000*Ep(1,1)/1000*h_air_naturel ;
  P_CONV_NAT_GAUCHE(dofs_source_conv_naturel_gauche_ext_haut,1) = T_air*layer/2000*Ep(1,3)/1000*h_air_naturel ;
  
  [dofs_source_conv_naturel_droite_milieu_bas] = finddofs (1,nely,[4],nelx,nely) ;
  [dofs_source_conv_naturel_droite_milieu_haut] = finddofs (3,nely,[2],nelx,nely) ;
  [dofs_source_conv_naturel_droite_ext_bas] = finddofs (1,nely,[2],nelx,nely) ;
  [dofs_source_conv_naturel_droite_ext_haut] = finddofs (3,nely,[4],nelx,nely) ;
  
  P_CONV_NAT_DROITE(dofs_source_conv_naturel_droite_milieu_bas,1) = T_air*layer/2000*Ep(1,1)/1000*h_air_naturel + T_air*layer/2000*Ep(1,2)/1000*h_air_naturel ;
  P_CONV_NAT_DROITE(dofs_source_conv_naturel_droite_milieu_haut,1) = T_air*layer/2000*Ep(1,2)/1000*h_air_naturel + T_air*layer/2000*Ep(1,3)/1000*h_air_naturel ;
  P_CONV_NAT_DROITE(dofs_source_conv_naturel_droite_ext_bas,1) = T_air*layer/2000*Ep(1,1)/1000*h_air_naturel ;
  P_CONV_NAT_DROITE(dofs_source_conv_naturel_droite_ext_haut,1) = T_air*layer/2000*Ep(1,3)/1000*h_air_naturel ;
  
  end
  
  if nelx_piece > 3
    
  [dofs_source_conv_naturel_gauche] = finddofs (2:nelx_piece-1,1,[13],nelx,nely) ;
  [dofs_source_conv_naturel_gauche_ext_bas] = finddofs (1,1,[1],nelx,nely) ;
  [dofs_source_conv_naturel_gauche_ext_haut] = finddofs (nelx_piece,1,[3],nelx,nely) ;

  P_CONV_NAT_GAUCHE(dofs_source_conv_naturel_gauche,1) = T_air*layer/2000*Ep(1,1:nelx_piece-1)/1000*h_air_naturel + T_air*layer/2000*Ep(1,2:nelx_piece)/1000*h_air_naturel ;
  P_CONV_NAT_GAUCHE(dofs_source_conv_naturel_gauche_ext_bas,1) = T_air*layer/2000*Ep(1,1)/1000*h_air_naturel ;
  P_CONV_NAT_GAUCHE(dofs_source_conv_naturel_gauche_ext_haut,1) = T_air*layer/2000*Ep(1,nelx_piece)/1000*h_air_naturel ;

  [dofs_source_conv_naturel_droite] = finddofs (2:nelx_piece-1,nely,[24],nelx,nely) ;
  [dofs_source_conv_naturel_droite_ext_bas] = finddofs (1,nely,[2],nelx,nely) ;
  [dofs_source_conv_naturel_droite_ext_haut] = finddofs (nelx_piece,nely,[4],nelx,nely) ;

  P_CONV_NAT_DROITE(dofs_source_conv_naturel_droite,1) = T_air*layer/2000*Ep(1,1:nelx_piece-1)/1000*h_air_naturel + T_air*layer/2000*Ep(1,2:nelx_piece)/1000*h_air_naturel ;
  P_CONV_NAT_DROITE(dofs_source_conv_naturel_droite_ext_bas,1) = T_air*layer/2000*Ep(1,1)/1000*h_air_naturel ;
  P_CONV_NAT_DROITE(dofs_source_conv_naturel_droite_ext_haut,1) = T_air*layer/2000*Ep(1,nelx_piece)/1000*h_air_naturel ;

  end

end

% REPRESENTATION GRAPHIQUE DU CHAMP DE CHARGES THERMIQUES (REELLES & FICTIVES)

% P_ToPlot = reshape(P,(nely+1),(nelx+1)) ;
% 
% fig = figure('Name','Champ de charges thermiques','NumberTitle','on')
% hold on 
% colormap(jet) ;
% contourf(P_ToPlot) ;
% colorbar ;
% view (-90,90) ; % inversion des axes
% set(gca,'YDir','reverse') ; % retournement de l'axe Y
% saveas(fig,'charges') ;

%% CALCUL DU TEMPS DE CHARGE (FLASH LASER) ET DECHARGE (REFROIDISSEMENT Y COMPRIS APPLICATION POUDRE)

% TEMPS DE CHARGE

    Ep_nelx_piece = Ep(1,nelx_piece) ; % calcul de l'paisseur de la couche en production

    % CALCUL DE LA LARGEUR DE LA PIECE (COUCHE EN PRODUCTION)
    
    if FORME == 2 % PYRAMIDE

    largeur_haut_piece = largeur_ref ; % largeur en partie haute pice (pyramide)  fabriquer (mm)
    largeur_nelx_piece = 2*layer*round(tand(3)*(nelx-nelx_piece),2) + largeur_haut_piece ; % calcul largeur de la piece (couche en production)
    
    else
        
    largeur_nelx_piece = largeur_ref ;
    
    end

    Surf_nelx_piece = Ep_nelx_piece * largeur_nelx_piece ; % Surface d'application de charge laser
    
    hatch_space = 0.13 ; % cart entre fasiceaux laser
    
    vitesse_laser = 673 ; % vitesse de dplacement du laser (mm/s)
    
    t_nelx_piece_charge = Surf_nelx_piece / (hatch_space*vitesse_laser) ; % calcul du temps de charge (s)
  
    t_nelx_piece_charge = round (t_nelx_piece_charge,1) ; % arrondi vers multiple 0,1
       
% TEMPS DE DECHARGE

    t_nelx_piece_decharge = 25 ; % calcul / imposition du temps de dcharge (s)
    
%% NOMBRE DE CHARGES / DECHARGES PAR COUCHE

for cycle = 1:nb_cycles
        
%% CALCUL DU CHAMP DE TEMPERATURE EN CHARGE

P  = P_LASER + P_CONV_FORCEE + P_CONV_NAT_GAUCHE + P_CONV_NAT_DROITE ;

nb_iter_charge = round(t_nelx_piece_charge / delta_t) ; % calcul nb itrations charge

nb_iter_charge = int64(nb_iter_charge) ; % transformation en "integer" pour boucle "for"

for i = 1:nb_iter_charge

    delta_T(freedofs,:) = (C(freedofs,freedofs)+ K(freedofs,freedofs)*delta_t) \ (delta_t*(P(freedofs,:)-K(freedofs,fixeddofs)*T(fixeddofs,:)-K(freedofs,freedofs)*T0(freedofs,:))) ;
    
    T(freedofs,:) = T0(freedofs,:) + delta_T(freedofs,:) ;
    
    round(T,3) ;

    T0(freedofs,:) =  T(freedofs,:) ;
    
    % REPRESENTATION GRAPHIQUE DU CHAMP DE TEMPERATURE & GRADIENT CENTRAL

    %LISTE_T {iter+1} = T ; % ajout du champ de T dans la listes des champs de T
    T_MAX (iter+1) =  max(T) ; % ajout de la valeur max  la liste des valeurs max
    iter = length(T_MAX) % incrmentation de la valeur de "iter"
        
    if nelx_piece == nelx_piece_final
    if cycle == nb_cycles   
    
        T_ToPlot = reshape(T,(nely+1),(nelx+1)) ;
        fig = figure(iter);
        set(fig,'visible','off'); % visualisation des champs successifs (ou non) !!

        colormap(jet);
        [c,h]=contourf(T_ToPlot) ;
        set(h,'edgecolor','none') ; % "lissage" du graphique

        cmin=0 ;
        cmax=1000 ;
        caxis([cmin cmax]) ;
        colorbar ;

        view (-90,90) ; % inversion des axes
        set(gca,'YDir','reverse') ; % retournement de l'axe Y
    
        saveas(fig,'Temp_finale') ;
        
        [dofs_gard_central] = finddofs (1:nelx_piece,nely/2,[24],nelx,nely) ; % noeuds centraux
        gradient = plot (T(dofs_gard_central,:)) ; % affichage courbe gradient central
        set(gradient,'visible','on'); % visualisation des gradients successifs (ou non) !!
        saveas(gradient,'Gradient_final') ;
        
         % REPRESENTATION GRAPHIQUE DE LA REPARTITION DES "LAMBDAS"

%         fig = figure('Name','Mapping lambda','NumberTitle','on')
%         hold on
%         colormap(jet);
%         contourf(lambda);
%         colorbar ;
%         view (-90,90) ; % inversion des axes
%         set(gca,'YDir','reverse') ; % retournement de l'axe Y
%         saveas(fig,'lambdas') ;
%         
%         fig = figure('Name','Mapping lambda','NumberTitle','on')
%         hold on
%         colormap(jet);
%         contourf(mat_lambda_titane);
%         colorbar ;
%         view (-90,90) ; % inversion des axes
%         set(gca,'YDir','reverse') ; % retournement de l'axe Y
%         saveas(fig,'mat_lambda_titane') ;
%         
%         fig = figure('Name','Mapping lambda','NumberTitle','on')
%         hold on
%         colormap(jet);
%         contourf(mat_lambda_poudre);
%         colorbar ;
%         view (-90,90) ; % inversion des axes
%         set(gca,'YDir','reverse') ; % retournement de l'axe Y
%         saveas(fig,'mat_lambda_poudre') ;
        
        %f = getframe;
        %writeVideo(vidObj,f); % criture du champ de T dans la video
        
    end
    end
    
end

%% CALCUL DU CHAMP DE TEMPERATURE EN DECHARGE

P  = P_CONV_FORCEE + P_CONV_NAT_GAUCHE + P_CONV_NAT_DROITE ;

delta_t_decharge = delta_t * 10 ;

nb_iter_decharge = round(t_nelx_piece_decharge / delta_t_decharge) ; % calcul nb itrations charge

for i = 1:nb_iter_decharge
    
    delta_T(freedofs,:) = (C(freedofs,freedofs)+ K(freedofs,freedofs)*delta_t_decharge) \ (delta_t_decharge*(P(freedofs,:)-K(freedofs,fixeddofs)*T(fixeddofs,:)-K(freedofs,freedofs)*T0(freedofs,:))) ;

    T(freedofs,:) = T0(freedofs,:) + delta_T(freedofs,:) ;
    
    round(T,3) ;

    T0(freedofs,:) =  T(freedofs,:) ;
    
    % REPRESENTATION GRAPHIQUE DU CHAMP DE TEMPERATURE

    %T_ToPlot = reshape(T,(nely+1),(nelx+1)) ;

    %LISTE_T {iter+1} = T ; % ajout du champ de T dans la listes des champs de T
    T_MAX (iter+1) =  max(T) ; % ajout de la valeur max  la liste des valeurs max
    iter = length(T_MAX) ; % incrmentation de la valeur de "iter"

    %fig = figure(iter);
    %set(fig,'visible','off'); % visualisation des champs successifs (ou non) !!
 
    %colormap(jet);
    %[c,h]=contourf(T_ToPlot) ;
    %set(h,'edgecolor','none') ; % "lissage" du graphique
    
    %cmin=0 ;
    %cmax=1000 ;
    %caxis([cmin cmax]) ;
    %colorbar ;

    %view (-90,90) ; % inversion des axes
    %set(gca,'YDir','reverse') ; % retournement de l'axe Y

    %f = getframe;
    %writeVideo(vidObj,f); % criture du champ de T dans la video
    
end

end

end

%close(vidObj) ; % fermeture du fichier "video"

%% PLOT COURBE DE TEMPERATURE

figure('Name','COURBE DE TEMPERATURES MAX','NumberTitle','off')
h = plot(1:iter,T_MAX) ;

%% FINALISATION

toc % fin temps de calcul

%% REPRESENTATION GRAPHIQUE D'UN CHAMP DE TEMPERATURE AU CHOIX (INSTANT t = ?? sec) / FINAL !!

% prompt = 'Instant t = ?? (sec)   ' ;
% instant_t = input(prompt) ;
% 
% no_iteration = int64(instant_t / delta_t) ;
% T = LISTE_T {no_iteration} ;
% T_ToPlot = reshape(T,(nely+1),(nelx+1)) ;
% 
% fig = figure('Name','Champ T instant t','NumberTitle','off')

% fig = figure('Name','Champ T final','NumberTitle','off')

% hold on
% colormap(jet);
% [c,h]=contourf(T_ToPlot) ;
% set(h,'edgecolor','none') ; % "lissage" du graphique
% cmin=0 ;
% cmax=1000 ;
% caxis([cmin cmax]) ;
% colorbar ;
% 
% view (-90,90) ; % inversion des axes
% set(gca,'YDir','reverse') ; % retournement de l'axe Y
% 
% saveas(fig,'Temp_instant_t') ;
% saveas(fig,'Temp_finale') ;

%% FLUX DE CHALEUR CORRESPONDANT AU CHAMP DE TEMPERATURES CHOISI

% Bx = [ -1/4  1/4  1/4 -1/4];
% By = [ -1/4 -1/4  1/4  1/4];
%    
% PHI_X(1:nely,1:nelx) = 0 ;
% PHI_Y(1:nely,1:nelx) = 0 ;
% 
% for elx = 1:nelx
%     for ely = 1:nely
%         
%         [dofs_T1] = finddofs (elx,ely,[1],nelx,nely) ;
%         [dofs_T2] = finddofs (elx,ely,[3],nelx,nely) ;
%         [dofs_T3] = finddofs (elx,ely,[4],nelx,nely) ;
%         [dofs_T4] = finddofs (elx,ely,[2],nelx,nely) ;
% 
%         TE = zeros(1,4);
%         
%         TE1 =  T(dofs_T1);
%         TE2 =  T(dofs_T2);
%         TE3 =  T(dofs_T3);
%         TE4 =  T(dofs_T4);
% 
%         TE = [TE1 TE2 TE3 TE4] ;
%         TET = transpose (TE) ;
%         
%         PHI_X(ely,elx) = -lambda(ely,elx) * Bx * TET * 2 / layer * x(ely,elx) ;
%         PHI_Y(ely,elx) = -lambda(ely,elx) * By * TET * 2 / layer * x(ely,elx);
%          
%     end
% end
        
% REPRESENTATION GRAPHIQUE FLUX DE CHALEUR

% [x,y] = meshgrid(1:1:nelx,1:1:nely) ;
% 
% u = PHI_X ;
% v = PHI_Y ;
% 
% fig = figure('Name','Flux de chaleur','NumberTitle','off')
% hold on
% quiver(x,y,u,v)
% view (-90,90) ; % inversion des axes
% set(gca,'YDir','reverse') ; % retournement de l'axe Y
% saveas(fig,'flux') ;