%% Fonction qui trouve les numros de ddls donns 

% Arguments :
% elx :         Position de l'lment selon x 
% ely :         Position de l'lment selon y 
% pos :         [Noeuds o les ddls doivent tre trouvs ]
%       Noeuds :    1 : coin infrieur gauche       2 ----- 4        
%                   2 : coin suprieur gauche       |       |
%                   3 : coin infrieur droit        |       |
%                   4 : coin suprieur droit        1 ----- 3
%                   13 24 12 ou 34 indique le segment liant ces noeuds. 
% nelx :        Nombre total d'lments selon x 
% nely :        Nombre total d'lments selon y 

% Sorties :
% dofs :        vecteur contenant les numros des ddls cherchs 

function [dofs] = finddofs (elx,ely,pos,nelx,nely)
dofs = []; 

% Si on veut bloquer deux noeuds l'un  ct de l'autre sans en bloquer
% d'autres, il faut appeller deux fois la fonction pour rentrer deux fois
% dans le cas 1. Car un seul lment concern donc ne rentrera pas dans le
% cas 2 et 3

% Cas d'un seul noeud concern 
if (length(elx)==1 && length(ely)==1)
    if(elx<=0 || elx>nelx ||ely<=0||ely>nely)
        error('Erreur - mauvaise dfinition de la position des lments'); 
    end
    n1 = (nely+1)*(elx-1)+ely; 
    n2 = (nely+1)* elx   +ely;
    if      pos == 1      dofs = [dofs n1];   end
    if      pos == 2      dofs = [dofs n1+1];     end
    if      pos == 3      dofs = [dofs n2];     end
    if      pos == 4      dofs = [dofs n2+1];     end
    
% Cas d'un segment le long de x 
elseif length(elx)~=1 
    if(min(elx)<=0 || max(elx)>nelx ||ely<=0||ely>nely)
        error('Erreur - mauvaise dfinition de la position des lments'); 
    end
    for i=1:length(elx)
        n1 = (nely+1)*(elx(i)-1)+ely; 
        n2 = (nely+1)* elx(i)   +ely;
        if      pos == 13  dofs = [dofs n1 n2];    end 
        if      pos == 24  dofs = [dofs n1+1 n2+1];    end 
    end 
    dofs = unique(dofs); 

% Cas d'un segment le long de y
elseif length(ely)~=1
    if(min(ely)<=0 || max(ely)>nely ||elx<=0||elx>nelx)
        error('Erreur - mauvaise dfinition de la position des lments'); 
    end
    for i=1:length(ely)
        n1 = (nely+1)*(elx-1)+ely(i); 
        n2 = (nely+1)* elx   +ely(i);
        if      pos == 12  dofs = [dofs n1 n1+1];    end 
        if      pos == 34  dofs = [dofs n2 n2+1];    end 
    end 
    dofs = unique(dofs); 
end 
    
end 